' Demo.vb : 
'CxTranslator algorithm
'Copyright  2001-2005 Easy Math Solution. All Rights Reserved
'http://www.e-MathSolution.com
'For details contact us: info@e-MathSolution.com

Module Module1

    Sub Main()
        On Error GoTo errHnd
        Dim expr As String
        Dim arg() As EMS.Complex
        Dim res As EMS.Complex
        Dim tr As EMS.CxTranslator
        Dim pi2 As EMS.Complex
        Dim qb As EMS.CxTranslator.CallBackUserFunction

        arg = New EMS.Complex(3) {}
        tr = New EMS.CxTranslator()
        arg(0).re = 3
        arg(0).im = 2

        arg(1).re = 5.6
        arg(1).im = -5

        arg(2).re = 15.6
        arg(2).im = 3.12

        pi2.re = 6.28
        pi2.im = 0

        expr = "f(x,y,z)=x*(-y)+5.4789i*exp(sqrt(x/z))-pi2"


        qb = New EMS.CxTranslator.CallBackUserFunction(AddressOf qub)
        tr.AddFunction("qub", qb)
        tr.AddConst("pi2", pi2)

        tr.SetEquTranslatorException()

        res = tr.EvaluateEqu(expr, arg(0))
        System.Console.WriteLine("res.re={0}   res.im={1}", res.re, res.im)

        res = tr.Evaluate("x,y", "qub(x)+exp(y)", arg(0))
        System.Console.WriteLine("res.re={0}   res.im={1}", res.re, res.im)

        tr.RemoveConst("pi2")
        tr.BuildEqu(expr)
        res = tr.CalcFor(arg(0))
        System.Console.WriteLine("res.re={0}   res.im={1}", res.re, res.im)

errHnd:  'Error
        Dim s As String
        s = Err.Description
        System.Console.WriteLine(Err.Description)

    End Sub

    'User defined function
    Function qub(ByRef x As EMS.Complex) As EMS.Complex
        Dim res As EMS.Complex
        res.re = x.re * x.re * x.re
        res.im = x.im * x.im * x.im
        qub = res
    End Function
End Module
